package org.distributeme.support.eventservice.generated;
//CHECKSTYLE:OFF

import java.util.List;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.concurrent.ConcurrentMap;
import java.util.concurrent.ConcurrentHashMap;
import org.apache.log4j.Logger;
import java.rmi.RemoteException;
import java.rmi.NotBoundException;
import org.distributeme.core.RegistryUtil;
import java.rmi.registry.LocateRegistry;
import java.rmi.registry.Registry;
import org.distributeme.core.ServiceDescriptor;
import org.distributeme.core.ServiceDescriptor.Protocol;
import org.distributeme.core.DiscoveryMode;
import org.distributeme.core.failing.FailingStrategy;
import org.distributeme.core.concurrencycontrol.ConcurrencyControlStrategy;
import org.distributeme.core.failing.FailDecision;
import org.distributeme.core.ClientSideCallContext;
import org.distributeme.core.exception.DistributemeRuntimeException;
import org.distributeme.core.exception.NoConnectionToServerException;
import org.distributeme.core.exception.ServiceUnavailableException;
import org.distributeme.core.Defaults;
import org.distributeme.core.interceptor.ClientSideRequestInterceptor;
import org.distributeme.core.interceptor.InterceptorRegistry;
import org.distributeme.core.interceptor.InterceptorResponse;
import org.distributeme.core.interceptor.InterceptionContext;
import org.distributeme.core.interceptor.InterceptionPhase;

public class RemoteEventServiceRMIBridgeServiceStub implements org.distributeme.support.eventservice.EventServiceRMIBridgeService{


	private volatile ConcurrentMap<String,RemoteEventServiceRMIBridgeService> delegates = new ConcurrentHashMap<String,RemoteEventServiceRMIBridgeService>();

	private DiscoveryMode discoveryMode = DiscoveryMode.AUTO;

	// ROUTER DECL V2
	// No class-wide-router set, skipping.

	// Method wide routers if applicable 
	// Method wide routers END 

	// ROUTER DECL V2 end

	// Failing
	// Class wide failing strategy 
	private FailingStrategy clazzWideFailingStrategy = Defaults.getDefaultFailingStrategy();

	private FailingStrategy deliverEventFailingStrategy_netanotheriaanopriseeventserviceEventTransportShellshell = clazzWideFailingStrategy;
	private FailingStrategy registerRemoteConsumerFailingStrategy_javalangStringchannelName_orgdistributemecoreServiceDescriptormyReference = clazzWideFailingStrategy;
	private FailingStrategy registerRemoteSupplierFailingStrategy_javalangStringchannelName_orgdistributemecoreServiceDescriptormyReference = clazzWideFailingStrategy;
	private FailingStrategy getInstanceIdFailingStrategy = clazzWideFailingStrategy;
	// Failing end

	// CONCURRENCY CONTROL
	// Class wide concurrency control strategy 
	private ConcurrencyControlStrategy clazzWideCCStrategy = Defaults.getDefaultConcurrencyControlStrategy();

	private ConcurrencyControlStrategy deliverEventCCStrategy_netanotheriaanopriseeventserviceEventTransportShellshell = clazzWideCCStrategy;
	private ConcurrencyControlStrategy registerRemoteConsumerCCStrategy_javalangStringchannelName_orgdistributemecoreServiceDescriptormyReference = clazzWideCCStrategy;
	private ConcurrencyControlStrategy registerRemoteSupplierCCStrategy_javalangStringchannelName_orgdistributemecoreServiceDescriptormyReference = clazzWideCCStrategy;
	private ConcurrencyControlStrategy getInstanceIdCCStrategy = clazzWideCCStrategy;
	// CONCURRENCY CONTROL end

	public RemoteEventServiceRMIBridgeServiceStub(){
		discoveryMode = DiscoveryMode.AUTO;
	}

	private ServiceDescriptor manuallySetDescriptor;
	private RemoteEventServiceRMIBridgeService manuallySetTarget;

	public RemoteEventServiceRMIBridgeServiceStub(ServiceDescriptor target){
		discoveryMode = DiscoveryMode.MANUAL;
		manuallySetDescriptor = target;
		try{
			manuallySetTarget = lookup(manuallySetDescriptor);
		}catch(NoConnectionToServerException e){
			throw new IllegalStateException("Can not resolve manually set reference", e);
		}
	}

	public void deliverEvent(net.anotheria.anoprise.eventservice.EventTransportShell shell) throws org.distributeme.support.eventservice.EventServiceRMIBridgeServiceException{
		deliverEvent(shell, (ClientSideCallContext)null);
	} //...public void deliverEvent(net.anotheria.anoprise.eventservice.EventTransportShell shell) throws org.distributeme.support.eventservice.EventServiceRMIBridgeServiceException

	private void deliverEvent(net.anotheria.anoprise.eventservice.EventTransportShell shell, org.distributeme.core.ClientSideCallContext diMeCallContext) throws org.distributeme.support.eventservice.EventServiceRMIBridgeServiceException{
		List __fromServerSide = null;;
		Exception exceptionInMethod = null;
		if (diMeCallContext == null)
			diMeCallContext = new ClientSideCallContext("deliverEvent");
		if (discoveryMode==DiscoveryMode.AUTO && diMeCallContext.getServiceId()==null)
			diMeCallContext.setServiceId(EventServiceRMIBridgeServiceConstants.getServiceId());

		HashMap __transportableCallContext = diMeCallContext.getTransportableCallContext();
		// Initialize interceptors
		List<ClientSideRequestInterceptor> diMeInterceptors = InterceptorRegistry.getInstance().getClientSideRequestInterceptors();
		InterceptionContext diMeInterceptionContext = new InterceptionContext();
		// Concurrency control, client side - start
		deliverEventCCStrategy_netanotheriaanopriseeventserviceEventTransportShellshell.notifyClientSideCallStarted(diMeCallContext);

		ArrayList<Object> diMeParameters = new ArrayList<Object>();
		diMeParameters.add(shell);
		diMeCallContext.setParameters(diMeParameters);
		try{
			diMeInterceptionContext.setCurrentPhase(InterceptionPhase.BEFORE_SERVICE_CALL);
			for (ClientSideRequestInterceptor interceptor : diMeInterceptors){
				InterceptorResponse interceptorResponse = interceptor.beforeServiceCall(diMeCallContext, diMeInterceptionContext);
				switch(interceptorResponse.getCommand()){
				case ABORT:
					if (interceptorResponse.getException() instanceof RuntimeException)
						throw (RuntimeException) interceptorResponse.getException();
					if (interceptorResponse.getException() instanceof org.distributeme.support.eventservice.EventServiceRMIBridgeServiceException)
						throw (org.distributeme.support.eventservice.EventServiceRMIBridgeServiceException) interceptorResponse.getException();
					throw new RuntimeException("Interceptor exception",interceptorResponse.getException());
				case RETURN:
					return;
				case CONTINUE:
					break;
				default:
					throw new IllegalStateException("Unsupported or unexpected command from interceptor " + interceptorResponse.getCommand()+ " in phase:"+diMeInterceptionContext.getCurrentPhase());
				} //...switch
			} //...for
			// Reparse parameters in case an interceptor modified them
			shell = (net.anotheria.anoprise.eventservice.EventTransportShell) diMeParameters.get(0);
			__fromServerSide = getDelegate(diMeCallContext.getServiceId()).deliverEvent(shell,  __transportableCallContext);
			__transportableCallContext.putAll(((HashMap)__fromServerSide.get(1)));
			return;
		}catch(RemoteException e){
			// handle exceptions properly
			e.printStackTrace();
			notifyDelegateFailed(diMeCallContext.getServiceId());
			exceptionInMethod = e;
		}catch(NoConnectionToServerException e){
			exceptionInMethod = e;
		}finally{
		// Concurrency control, client side - end
			deliverEventCCStrategy_netanotheriaanopriseeventserviceEventTransportShellshell.notifyClientSideCallFinished(diMeCallContext);
		diMeInterceptionContext.setCurrentPhase(InterceptionPhase.AFTER_SERVICE_CALL);
		if (__fromServerSide!=null){
			diMeInterceptionContext.setReturnValue(__fromServerSide.get(0));
		}
		diMeInterceptionContext.setException(exceptionInMethod);
		boolean diMeReturnOverriden = false;
		for (ClientSideRequestInterceptor interceptor : diMeInterceptors){
			InterceptorResponse interceptorResponse = interceptor.afterServiceCall(diMeCallContext, diMeInterceptionContext);
			switch(interceptorResponse.getCommand()){
			case ABORT:
				if (interceptorResponse.getException() instanceof RuntimeException)
					throw (RuntimeException) interceptorResponse.getException();
				if (interceptorResponse.getException() instanceof org.distributeme.support.eventservice.EventServiceRMIBridgeServiceException)
					throw (org.distributeme.support.eventservice.EventServiceRMIBridgeServiceException) interceptorResponse.getException();
				throw new RuntimeException("Interceptor exception",interceptorResponse.getException());
			case RETURN:
				return;
			case CONTINUE:
				break;
			default:
				throw new IllegalStateException("Unsupported or unexpected command from interceptor " + interceptorResponse.getCommand()+ " in phase:"+diMeInterceptionContext.getCurrentPhase());
			} //...switch
		} //...for
		}
		// Failing
		if (exceptionInMethod!=null){
			FailDecision failDecision = deliverEventFailingStrategy_netanotheriaanopriseeventserviceEventTransportShellshell.callFailed(diMeCallContext);
			if (failDecision.getTargetService()!=null)
				diMeCallContext.setServiceId(failDecision.getTargetService());
			switch(failDecision.getReaction()){
				case RETRY:
					deliverEvent(shell, diMeCallContext.increaseCallCount());
					return;
				case RETRYONCE:
					// Only retry if its the first call
					if (!diMeCallContext.isFirstCall())
						break;
					deliverEvent(shell, diMeCallContext.increaseCallCount());
					return;
				case FAIL:
				default:
				// Fail or default is to do nothing at all and let the request fail
			} //...switch(failDecision)
		}
		// fail through, if we are here, we must have had an exception before.
		throw mapException(exceptionInMethod);
	}

	public void registerRemoteConsumer(java.lang.String channelName, org.distributeme.core.ServiceDescriptor myReference) throws org.distributeme.support.eventservice.EventServiceRMIBridgeServiceException{
		registerRemoteConsumer(channelName, myReference, (ClientSideCallContext)null);
	} //...public void registerRemoteConsumer(java.lang.String channelName, org.distributeme.core.ServiceDescriptor myReference) throws org.distributeme.support.eventservice.EventServiceRMIBridgeServiceException

	private void registerRemoteConsumer(java.lang.String channelName, org.distributeme.core.ServiceDescriptor myReference, org.distributeme.core.ClientSideCallContext diMeCallContext) throws org.distributeme.support.eventservice.EventServiceRMIBridgeServiceException{
		List __fromServerSide = null;;
		Exception exceptionInMethod = null;
		if (diMeCallContext == null)
			diMeCallContext = new ClientSideCallContext("registerRemoteConsumer");
		if (discoveryMode==DiscoveryMode.AUTO && diMeCallContext.getServiceId()==null)
			diMeCallContext.setServiceId(EventServiceRMIBridgeServiceConstants.getServiceId());

		HashMap __transportableCallContext = diMeCallContext.getTransportableCallContext();
		// Initialize interceptors
		List<ClientSideRequestInterceptor> diMeInterceptors = InterceptorRegistry.getInstance().getClientSideRequestInterceptors();
		InterceptionContext diMeInterceptionContext = new InterceptionContext();
		// Concurrency control, client side - start
		registerRemoteConsumerCCStrategy_javalangStringchannelName_orgdistributemecoreServiceDescriptormyReference.notifyClientSideCallStarted(diMeCallContext);

		ArrayList<Object> diMeParameters = new ArrayList<Object>();
		diMeParameters.add(channelName);
		diMeParameters.add(myReference);
		diMeCallContext.setParameters(diMeParameters);
		try{
			diMeInterceptionContext.setCurrentPhase(InterceptionPhase.BEFORE_SERVICE_CALL);
			for (ClientSideRequestInterceptor interceptor : diMeInterceptors){
				InterceptorResponse interceptorResponse = interceptor.beforeServiceCall(diMeCallContext, diMeInterceptionContext);
				switch(interceptorResponse.getCommand()){
				case ABORT:
					if (interceptorResponse.getException() instanceof RuntimeException)
						throw (RuntimeException) interceptorResponse.getException();
					if (interceptorResponse.getException() instanceof org.distributeme.support.eventservice.EventServiceRMIBridgeServiceException)
						throw (org.distributeme.support.eventservice.EventServiceRMIBridgeServiceException) interceptorResponse.getException();
					throw new RuntimeException("Interceptor exception",interceptorResponse.getException());
				case RETURN:
					return;
				case CONTINUE:
					break;
				default:
					throw new IllegalStateException("Unsupported or unexpected command from interceptor " + interceptorResponse.getCommand()+ " in phase:"+diMeInterceptionContext.getCurrentPhase());
				} //...switch
			} //...for
			// Reparse parameters in case an interceptor modified them
			channelName = (java.lang.String) diMeParameters.get(0);
			myReference = (org.distributeme.core.ServiceDescriptor) diMeParameters.get(1);
			__fromServerSide = getDelegate(diMeCallContext.getServiceId()).registerRemoteConsumer(channelName, myReference,  __transportableCallContext);
			__transportableCallContext.putAll(((HashMap)__fromServerSide.get(1)));
			return;
		}catch(RemoteException e){
			// handle exceptions properly
			e.printStackTrace();
			notifyDelegateFailed(diMeCallContext.getServiceId());
			exceptionInMethod = e;
		}catch(NoConnectionToServerException e){
			exceptionInMethod = e;
		}finally{
		// Concurrency control, client side - end
			registerRemoteConsumerCCStrategy_javalangStringchannelName_orgdistributemecoreServiceDescriptormyReference.notifyClientSideCallFinished(diMeCallContext);
		diMeInterceptionContext.setCurrentPhase(InterceptionPhase.AFTER_SERVICE_CALL);
		if (__fromServerSide!=null){
			diMeInterceptionContext.setReturnValue(__fromServerSide.get(0));
		}
		diMeInterceptionContext.setException(exceptionInMethod);
		boolean diMeReturnOverriden = false;
		for (ClientSideRequestInterceptor interceptor : diMeInterceptors){
			InterceptorResponse interceptorResponse = interceptor.afterServiceCall(diMeCallContext, diMeInterceptionContext);
			switch(interceptorResponse.getCommand()){
			case ABORT:
				if (interceptorResponse.getException() instanceof RuntimeException)
					throw (RuntimeException) interceptorResponse.getException();
				if (interceptorResponse.getException() instanceof org.distributeme.support.eventservice.EventServiceRMIBridgeServiceException)
					throw (org.distributeme.support.eventservice.EventServiceRMIBridgeServiceException) interceptorResponse.getException();
				throw new RuntimeException("Interceptor exception",interceptorResponse.getException());
			case RETURN:
				return;
			case CONTINUE:
				break;
			default:
				throw new IllegalStateException("Unsupported or unexpected command from interceptor " + interceptorResponse.getCommand()+ " in phase:"+diMeInterceptionContext.getCurrentPhase());
			} //...switch
		} //...for
		}
		// Failing
		if (exceptionInMethod!=null){
			FailDecision failDecision = registerRemoteConsumerFailingStrategy_javalangStringchannelName_orgdistributemecoreServiceDescriptormyReference.callFailed(diMeCallContext);
			if (failDecision.getTargetService()!=null)
				diMeCallContext.setServiceId(failDecision.getTargetService());
			switch(failDecision.getReaction()){
				case RETRY:
					registerRemoteConsumer(channelName, myReference, diMeCallContext.increaseCallCount());
					return;
				case RETRYONCE:
					// Only retry if its the first call
					if (!diMeCallContext.isFirstCall())
						break;
					registerRemoteConsumer(channelName, myReference, diMeCallContext.increaseCallCount());
					return;
				case FAIL:
				default:
				// Fail or default is to do nothing at all and let the request fail
			} //...switch(failDecision)
		}
		// fail through, if we are here, we must have had an exception before.
		throw mapException(exceptionInMethod);
	}

	public void registerRemoteSupplier(java.lang.String channelName, org.distributeme.core.ServiceDescriptor myReference) throws org.distributeme.support.eventservice.EventServiceRMIBridgeServiceException{
		registerRemoteSupplier(channelName, myReference, (ClientSideCallContext)null);
	} //...public void registerRemoteSupplier(java.lang.String channelName, org.distributeme.core.ServiceDescriptor myReference) throws org.distributeme.support.eventservice.EventServiceRMIBridgeServiceException

	private void registerRemoteSupplier(java.lang.String channelName, org.distributeme.core.ServiceDescriptor myReference, org.distributeme.core.ClientSideCallContext diMeCallContext) throws org.distributeme.support.eventservice.EventServiceRMIBridgeServiceException{
		List __fromServerSide = null;;
		Exception exceptionInMethod = null;
		if (diMeCallContext == null)
			diMeCallContext = new ClientSideCallContext("registerRemoteSupplier");
		if (discoveryMode==DiscoveryMode.AUTO && diMeCallContext.getServiceId()==null)
			diMeCallContext.setServiceId(EventServiceRMIBridgeServiceConstants.getServiceId());

		HashMap __transportableCallContext = diMeCallContext.getTransportableCallContext();
		// Initialize interceptors
		List<ClientSideRequestInterceptor> diMeInterceptors = InterceptorRegistry.getInstance().getClientSideRequestInterceptors();
		InterceptionContext diMeInterceptionContext = new InterceptionContext();
		// Concurrency control, client side - start
		registerRemoteSupplierCCStrategy_javalangStringchannelName_orgdistributemecoreServiceDescriptormyReference.notifyClientSideCallStarted(diMeCallContext);

		ArrayList<Object> diMeParameters = new ArrayList<Object>();
		diMeParameters.add(channelName);
		diMeParameters.add(myReference);
		diMeCallContext.setParameters(diMeParameters);
		try{
			diMeInterceptionContext.setCurrentPhase(InterceptionPhase.BEFORE_SERVICE_CALL);
			for (ClientSideRequestInterceptor interceptor : diMeInterceptors){
				InterceptorResponse interceptorResponse = interceptor.beforeServiceCall(diMeCallContext, diMeInterceptionContext);
				switch(interceptorResponse.getCommand()){
				case ABORT:
					if (interceptorResponse.getException() instanceof RuntimeException)
						throw (RuntimeException) interceptorResponse.getException();
					if (interceptorResponse.getException() instanceof org.distributeme.support.eventservice.EventServiceRMIBridgeServiceException)
						throw (org.distributeme.support.eventservice.EventServiceRMIBridgeServiceException) interceptorResponse.getException();
					throw new RuntimeException("Interceptor exception",interceptorResponse.getException());
				case RETURN:
					return;
				case CONTINUE:
					break;
				default:
					throw new IllegalStateException("Unsupported or unexpected command from interceptor " + interceptorResponse.getCommand()+ " in phase:"+diMeInterceptionContext.getCurrentPhase());
				} //...switch
			} //...for
			// Reparse parameters in case an interceptor modified them
			channelName = (java.lang.String) diMeParameters.get(0);
			myReference = (org.distributeme.core.ServiceDescriptor) diMeParameters.get(1);
			__fromServerSide = getDelegate(diMeCallContext.getServiceId()).registerRemoteSupplier(channelName, myReference,  __transportableCallContext);
			__transportableCallContext.putAll(((HashMap)__fromServerSide.get(1)));
			return;
		}catch(RemoteException e){
			// handle exceptions properly
			e.printStackTrace();
			notifyDelegateFailed(diMeCallContext.getServiceId());
			exceptionInMethod = e;
		}catch(NoConnectionToServerException e){
			exceptionInMethod = e;
		}finally{
		// Concurrency control, client side - end
			registerRemoteSupplierCCStrategy_javalangStringchannelName_orgdistributemecoreServiceDescriptormyReference.notifyClientSideCallFinished(diMeCallContext);
		diMeInterceptionContext.setCurrentPhase(InterceptionPhase.AFTER_SERVICE_CALL);
		if (__fromServerSide!=null){
			diMeInterceptionContext.setReturnValue(__fromServerSide.get(0));
		}
		diMeInterceptionContext.setException(exceptionInMethod);
		boolean diMeReturnOverriden = false;
		for (ClientSideRequestInterceptor interceptor : diMeInterceptors){
			InterceptorResponse interceptorResponse = interceptor.afterServiceCall(diMeCallContext, diMeInterceptionContext);
			switch(interceptorResponse.getCommand()){
			case ABORT:
				if (interceptorResponse.getException() instanceof RuntimeException)
					throw (RuntimeException) interceptorResponse.getException();
				if (interceptorResponse.getException() instanceof org.distributeme.support.eventservice.EventServiceRMIBridgeServiceException)
					throw (org.distributeme.support.eventservice.EventServiceRMIBridgeServiceException) interceptorResponse.getException();
				throw new RuntimeException("Interceptor exception",interceptorResponse.getException());
			case RETURN:
				return;
			case CONTINUE:
				break;
			default:
				throw new IllegalStateException("Unsupported or unexpected command from interceptor " + interceptorResponse.getCommand()+ " in phase:"+diMeInterceptionContext.getCurrentPhase());
			} //...switch
		} //...for
		}
		// Failing
		if (exceptionInMethod!=null){
			FailDecision failDecision = registerRemoteSupplierFailingStrategy_javalangStringchannelName_orgdistributemecoreServiceDescriptormyReference.callFailed(diMeCallContext);
			if (failDecision.getTargetService()!=null)
				diMeCallContext.setServiceId(failDecision.getTargetService());
			switch(failDecision.getReaction()){
				case RETRY:
					registerRemoteSupplier(channelName, myReference, diMeCallContext.increaseCallCount());
					return;
				case RETRYONCE:
					// Only retry if its the first call
					if (!diMeCallContext.isFirstCall())
						break;
					registerRemoteSupplier(channelName, myReference, diMeCallContext.increaseCallCount());
					return;
				case FAIL:
				default:
				// Fail or default is to do nothing at all and let the request fail
			} //...switch(failDecision)
		}
		// fail through, if we are here, we must have had an exception before.
		throw mapException(exceptionInMethod);
	}

	public java.lang.String getInstanceId() throws org.distributeme.support.eventservice.EventServiceRMIBridgeServiceException{
		return getInstanceId((ClientSideCallContext)null);
	} //...public java.lang.String getInstanceId() throws org.distributeme.support.eventservice.EventServiceRMIBridgeServiceException

	private java.lang.String getInstanceId(org.distributeme.core.ClientSideCallContext diMeCallContext) throws org.distributeme.support.eventservice.EventServiceRMIBridgeServiceException{
		List __fromServerSide = null;;
		Exception exceptionInMethod = null;
		if (diMeCallContext == null)
			diMeCallContext = new ClientSideCallContext("getInstanceId");
		if (discoveryMode==DiscoveryMode.AUTO && diMeCallContext.getServiceId()==null)
			diMeCallContext.setServiceId(EventServiceRMIBridgeServiceConstants.getServiceId());

		HashMap __transportableCallContext = diMeCallContext.getTransportableCallContext();
		// Initialize interceptors
		List<ClientSideRequestInterceptor> diMeInterceptors = InterceptorRegistry.getInstance().getClientSideRequestInterceptors();
		InterceptionContext diMeInterceptionContext = new InterceptionContext();
		// Concurrency control, client side - start
		getInstanceIdCCStrategy.notifyClientSideCallStarted(diMeCallContext);

		ArrayList<Object> diMeParameters = new ArrayList<Object>();
		diMeCallContext.setParameters(diMeParameters);
		try{
			diMeInterceptionContext.setCurrentPhase(InterceptionPhase.BEFORE_SERVICE_CALL);
			for (ClientSideRequestInterceptor interceptor : diMeInterceptors){
				InterceptorResponse interceptorResponse = interceptor.beforeServiceCall(diMeCallContext, diMeInterceptionContext);
				switch(interceptorResponse.getCommand()){
				case ABORT:
					if (interceptorResponse.getException() instanceof RuntimeException)
						throw (RuntimeException) interceptorResponse.getException();
					if (interceptorResponse.getException() instanceof org.distributeme.support.eventservice.EventServiceRMIBridgeServiceException)
						throw (org.distributeme.support.eventservice.EventServiceRMIBridgeServiceException) interceptorResponse.getException();
					throw new RuntimeException("Interceptor exception",interceptorResponse.getException());
				case RETURN:
					return (java.lang.String) interceptorResponse.getReturnValue();
				case CONTINUE:
					break;
				default:
					throw new IllegalStateException("Unsupported or unexpected command from interceptor " + interceptorResponse.getCommand()+ " in phase:"+diMeInterceptionContext.getCurrentPhase());
				} //...switch
			} //...for
			// Reparse parameters in case an interceptor modified them
			__fromServerSide = getDelegate(diMeCallContext.getServiceId()).getInstanceId( __transportableCallContext);
			__transportableCallContext.putAll(((HashMap)__fromServerSide.get(1)));
			return (java.lang.String) __fromServerSide.get(0);
		}catch(RemoteException e){
			// handle exceptions properly
			e.printStackTrace();
			notifyDelegateFailed(diMeCallContext.getServiceId());
			exceptionInMethod = e;
		}catch(NoConnectionToServerException e){
			exceptionInMethod = e;
		}finally{
		// Concurrency control, client side - end
			getInstanceIdCCStrategy.notifyClientSideCallFinished(diMeCallContext);
		diMeInterceptionContext.setCurrentPhase(InterceptionPhase.AFTER_SERVICE_CALL);
		if (__fromServerSide!=null){
			diMeInterceptionContext.setReturnValue(__fromServerSide.get(0));
		}
		diMeInterceptionContext.setException(exceptionInMethod);
		boolean diMeReturnOverriden = false;
		for (ClientSideRequestInterceptor interceptor : diMeInterceptors){
			InterceptorResponse interceptorResponse = interceptor.afterServiceCall(diMeCallContext, diMeInterceptionContext);
			switch(interceptorResponse.getCommand()){
			case ABORT:
				if (interceptorResponse.getException() instanceof RuntimeException)
					throw (RuntimeException) interceptorResponse.getException();
				if (interceptorResponse.getException() instanceof org.distributeme.support.eventservice.EventServiceRMIBridgeServiceException)
					throw (org.distributeme.support.eventservice.EventServiceRMIBridgeServiceException) interceptorResponse.getException();
				throw new RuntimeException("Interceptor exception",interceptorResponse.getException());
			case RETURN:
				return (java.lang.String) interceptorResponse.getReturnValue();
			case OVERWRITE_RETURN_AND_CONTINUE:
				__fromServerSide.set(0, interceptorResponse.getReturnValue());
				diMeInterceptionContext.setReturnValue(interceptorResponse.getReturnValue());
				diMeReturnOverriden = true;
				break;
			case CONTINUE:
				break;
			default:
				throw new IllegalStateException("Unsupported or unexpected command from interceptor " + interceptorResponse.getCommand()+ " in phase:"+diMeInterceptionContext.getCurrentPhase());
			} //...switch
		} //...for
		if (diMeReturnOverriden)
			return (java.lang.String) __fromServerSide.get(0);
		}
		// Failing
		if (exceptionInMethod!=null){
			FailDecision failDecision = getInstanceIdFailingStrategy.callFailed(diMeCallContext);
			if (failDecision.getTargetService()!=null)
				diMeCallContext.setServiceId(failDecision.getTargetService());
			switch(failDecision.getReaction()){
				case RETRY:
					return getInstanceId(diMeCallContext.increaseCallCount());
				case RETRYONCE:
					// Only retry if its the first call
					if (!diMeCallContext.isFirstCall())
						break;
					return getInstanceId(diMeCallContext.increaseCallCount());
				case FAIL:
				default:
				// Fail or default is to do nothing at all and let the request fail
			} //...switch(failDecision)
		}
		// fail through, if we are here, we must have had an exception before.
		throw mapException(exceptionInMethod);
	}


	private void notifyDelegateFailed(){
		notifyDelegateFailed(EventServiceRMIBridgeServiceConstants.getServiceId());
	}

	private void notifyDelegateFailed(String serviceId){
		if (serviceId!=null)
			delegates.remove(serviceId);
	}

	private RemoteEventServiceRMIBridgeService getDelegate() throws NoConnectionToServerException{
		if (discoveryMode==DiscoveryMode.MANUAL)
			return manuallySetTarget;
		return getDelegate(EventServiceRMIBridgeServiceConstants.getServiceId());
	}

	private RemoteEventServiceRMIBridgeService getDelegate(String serviceId) throws NoConnectionToServerException{
		// if no serviceid is provided, fallback to default resolve with manual mode
		if (serviceId==null)
			return getDelegate();
		RemoteEventServiceRMIBridgeService delegate = delegates.get(serviceId);
		if (delegate==null){
			try{
				delegate = lookup(serviceId);
				delegates.putIfAbsent(serviceId, delegate);
			}catch(Exception e){
			// //TODO - generate and throw typed exception.
				throw new NoConnectionToServerException("Couldn't lookup delegate because: "+e.getMessage()+" at "+RegistryUtil.describeRegistry(), e);
			}//try
		} //...first if (del==null) 
		return delegate;
	} //...fun

	private RemoteEventServiceRMIBridgeService lookup(String serviceId) throws NoConnectionToServerException{
		// //first we need to lookup target host.
		ServiceDescriptor toLookup = new ServiceDescriptor(Protocol.RMI, serviceId);
		ServiceDescriptor targetService = RegistryUtil.resolve(toLookup);
		if (targetService==null)
			throw new RuntimeException("Can't resolve host for an instance of "+EventServiceRMIBridgeServiceConstants.getServiceId());
		Registry registry = null;
		try{
			registry = LocateRegistry.getRegistry(targetService.getHost(), targetService.getPort());
		}catch(Exception e){
			System.err.println("lookup - couldn't obtain rmi registry on "+targetService+", aborting lookup"); e.printStackTrace();
			throw new NoConnectionToServerException("Can't resolve rmi registry for an instance of "+EventServiceRMIBridgeServiceConstants.getServiceId());
		}
		try{
			return (RemoteEventServiceRMIBridgeService) registry.lookup(serviceId);
		}catch(RemoteException e){
			throw new NoConnectionToServerException("Can't lookup service in the target rmi registry for an instance of "+serviceId, e);
		}catch(NotBoundException e){
			throw new NoConnectionToServerException("Can't lookup service in the target rmi registry for an instance of "+serviceId, e);
		}
	}

	private RemoteEventServiceRMIBridgeService lookup(ServiceDescriptor serviceDescriptor) throws NoConnectionToServerException{
		Registry registry = null;
		try{
			registry = LocateRegistry.getRegistry(serviceDescriptor.getHost(), serviceDescriptor.getPort());
		}catch(Exception e){
			System.err.println("lookup - couldn't obtain rmi registry on "+serviceDescriptor+", aborting lookup"); e.printStackTrace();
			throw new NoConnectionToServerException("Can't resolve rmi registry for "+serviceDescriptor);
		}
		try{
			return (RemoteEventServiceRMIBridgeService) registry.lookup(serviceDescriptor.getServiceId());
		}catch(RemoteException e){
			throw new NoConnectionToServerException("Can't lookup service in the target rmi registry for an instance of "+serviceDescriptor, e);
		}catch(NotBoundException e){
			throw new NoConnectionToServerException("Can't lookup service in the target rmi registry for an instance of "+serviceDescriptor, e);
		}
	}

	private DistributemeRuntimeException mapException(Exception in){
		if (in instanceof DistributemeRuntimeException)
			return (DistributemeRuntimeException) in;
		if (in instanceof RemoteException)
			return new ServiceUnavailableException ("Service unavailable due to rmi failure: "+in.getMessage(), in);
		return new ServiceUnavailableException("Unexpected exception: "+in.getMessage()+" " + in.getClass().getName(), in);
	}
}
